## sqlsmith 1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(SQLsmith LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(FeatureTests)

Option(USE_UPSTREAM_LIBPQXX "Fetch and use libpqxx from Github.")



# define our executable early, so we can set the properties, based on our dependencies
add_executable(sqlsmith)
target_sources(sqlsmith PRIVATE
        relmodel.cc schema.cc random.cc prod.cc expr.cc grammar.cc log.cc dump.cc impedance.cc sqlsmith.cc postgres.cc)

target_link_libraries(sqlsmith PostgreSQL::PostgreSQL)

# Workaround for outdated cmake packages on debian
set(PostgreSQL_ADDITIONAL_VERSIONS 11 12 13 14)
find_package(PostgreSQL REQUIRED)

if (NOT USE_UPSTREAM_LIBPQXX)
    # If we use the system pqxx library, we have to check for libpq.
    # This check is done by the CMakeLists.txt of the libpqxx project otherwise
    find_package(PQXX REQUIRED)

    if (PQXX_VERSION GREATER 7.0)
        set(HAVE_LIBPQXX7 TRUE)
    endif (PQXX_VERSION GREATER 7.0)

    target_link_libraries(sqlsmith PQXX::PQXX)
else (NOT USE_UPSTREAM_LIBPQXX)
    set(SKIP_BUILD_TEST TRUE)
    include(FetchContent)
    FetchContent_Declare(
            libpqxx
            GIT_REPOSITORY https://github.com/jtv/libpqxx.git
            GIT_TAG 7.6.0
    )
    FetchContent_MakeAvailable(libpqxx)
    FetchContent_GetProperties(libpqxx)
    unset(SKIP_BUILD_TEST)

    set(HAVE_LIBPQXX7 TRUE)

    target_include_directories(sqlsmith PRIVATE ${libpqxx_SOURCE_DIR}/include)
    target_link_libraries(sqlsmith pqxx)
endif (NOT USE_UPSTREAM_LIBPQXX)

if(NOT std_regex_ok)
    find_package(Boost REQUIRED COMPONENTS regex)
    set(REGEX_LIBRARY Boost::regex)
    set(HAVE_BOOST TRUE)
    set(HAVE_BOOST_REGEX TRUE)
endif(NOT std_regex_ok)

## optional dependencies
# sqlite
find_package(SQLite3)
if (SQLite3_FOUND)
    set(HAVE_LIBSQLITE3 TRUE)
    target_sources(sqlsmith PRIVATE sqlite.cc)
    target_link_libraries(sqlsmith SQLite::SQLite3)
endif ()

# monetdb
find_package(MonetDB)
if (MonetDB_FOUND)
    set(HAVE_MONETDB 1)
    target_sources(sqlsmith PRIVATE monetdb.cc)
    target_link_libraries(sqlsmith MonetDB::mapi)
endif ()


## target configuration
string(TOLOWER ${PROJECT_NAME} PACKAGE)
set(PACKAGE_NAME ${PROJECT_NAME})
configure_file(config_h.cmake.in config.h)


# get our git tag
set(GIT_TAG UNRELEASED)
execute_process(
        COMMAND git describe --exclude=debian* --dirty --tags --always
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE GIT_TAG
        OUTPUT_STRIP_TRAILING_WHITESPACE
)

# our gitrev.h
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/gitrev.h "#define GITREV \"${GIT_TAG}\"")

# make sure our target finds gitrev.h and config.h
target_include_directories(sqlsmith PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

## sqlsmith 1.0

=== debian/changelog ===
sqlsmith (1.0-1build4) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:24:25 +0000

sqlsmith (1.0-1build3) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:48:02 +0000

sqlsmith (1.0-1build2) yakkety; urgency=medium

  * No-change rebuild against latest libpqxx

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 28 Aug 2016 17:37:18 -0400

sqlsmith (1.0-1build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:32:36 +0000

sqlsmith (1.0-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Mon, 30 May 2016 10:17:16 +0200

=== debian/control ===
Source: sqlsmith
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Andreas Seltenreich <seltenreich@gmx.de>
Uploaders: Christoph Berg <myon@debian.org>
Standards-Version: 3.9.8
Homepage: https://github.com/anse1/sqlsmith
Vcs-Browser: https://github.com/anse1/sqlsmith
Vcs-Git: https://github.com/anse1/sqlsmith.git -b debian
Build-Depends:
 autoconf,
 autoconf-archive,
 debhelper (>= 9),
 libboost-regex-dev,
 libpqxx-dev (>= 4.0),

Package: sqlsmith
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: random SQL query generator
 SQLsmith is a random SQL query generator. Its paragon is Csmith, which proved
 valuable for quality assurance in C compilers.
 .
 It currently supports generating queries for PostgreSQL 9.5 or later only.
 SQLsmith was designed with testing different versions and even products in
 mind, but this has not manifested yet.
 .
 Besides PostgreSQL developers, users developing extensions of PostgreSQL might
 also be interested in exposing their code to SQLsmith's random workload.
 .
 During its prototyping stage, it already found about thirty bugs in
 PostgreSQL alphas, betas and releases, including security vulnerabilities in
 released versions.

## sqlsmith 1.2.1

=== debian/changelog ===
sqlsmith (1.2.1-2.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 10.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 06 Oct 2021 17:14:29 +0200

sqlsmith (1.2.1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure copyright file specification URI.
  * Bump debhelper from deprecated 9 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Christoph Berg ]
  * Support PG14's multirange types.
  * B-D on libssl-dev.

 -- Christoph Berg <myon@debian.org>  Wed, 06 Oct 2021 17:14:29 +0200

sqlsmith (1.2.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christoph Berg <myon@debian.org>  Fri, 04 May 2018 19:37:14 +0200

sqlsmith (1.2-1) unstable; urgency=medium

  * SQLsmith v1.2 is released.
  * Adds support for testing sqlite3.
  * Built without support for MonetDB since the latter is not packaged
    yet.

 -- Andreas Seltenreich <seltenreich@gmx.de>  Thu, 03 May 2018 08:46:07 +0200

=== debian/control ===
Source: sqlsmith
Section: database
Priority: optional
Maintainer: Andreas Seltenreich <seltenreich@gmx.de>
Uploaders: Christoph Berg <myon@debian.org>
Standards-Version: 4.6.0
Homepage: https://github.com/anse1/sqlsmith
Vcs-Browser: https://github.com/anse1/sqlsmith
Vcs-Git: https://github.com/anse1/sqlsmith.git -b debian
Build-Depends:
 autoconf,
 autoconf-archive,
 debhelper (>= 10),
 libboost-regex-dev,
 libpq-dev,
 libpqxx-dev (>= 4.0),
 libsqlite3-dev,
 libssl-dev,

Package: sqlsmith
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: random SQL query generator
 SQLsmith is a random SQL query generator. Its paragon is Csmith, which proved
 valuable for quality assurance in C compilers.
 .
 It currently supports generating queries for PostgreSQL 9.5+ and sqlite3.
 .
 Besides PostgreSQL developers, users developing extensions of PostgreSQL might
 also be interested in exposing their code to SQLsmith's random workload.
 .
 During its prototyping stage, it already found about thirty bugs in
 PostgreSQL alphas, betas and releases, including security vulnerabilities in
 released versions.

## sqlsmith 1.3

=== debian/changelog ===
sqlsmith (1.3-1build1) jammy; urgency=medium

  * No-change rebuild against libboost-regex1.74.0-icu70.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 10 Feb 2022 16:03:42 +0100

sqlsmith (1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Christoph Berg <myon@debian.org>  Tue, 11 Jan 2022 11:20:16 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Build-Depends:
  autoconf,
  autoconf-archive,
- debhelper (>= 10),
+ debhelper-compat (= 12),
  libboost-regex-dev,
  libpq-dev,
  libpqxx-dev (>= 4.0),

## sqlsmith 1.4~20220624.1101-2~3.git82ef743.pgdg21.10+1

=== debian/changelog ===
sqlsmith (1.4~20220624.1101-2~3.git82ef743.pgdg21.10+1) impish-pgdg; urgency=medium

  * Rebuild for impish-pgdg.
  * Changes applied by generate-pgdg-source:
    + Use source format 1.0 for git snapshot build.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Thu, 17 Mar 2022 12:49:00 -0000

sqlsmith (1.4-2) UNRELEASED; urgency=medium

  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libpqxx-dev.

 -- Debian Janitor <janitor@jelmer.uk>  Thu, 17 Mar 2022 12:49:00 -0000

sqlsmith (1.4-1) unstable; urgency=medium

  * New upstream release.
  * Remove libboost-regex-dev B-D, not required with modern g++.

 -- Christoph Berg <myon@debian.org>  Thu, 03 Mar 2022 09:33:23 +0100

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,8 @@
  autoconf,
  autoconf-archive,
  debhelper-compat (= 12),
- libboost-regex-dev,
  libpq-dev,
- libpqxx-dev (>= 4.0),
+ libpqxx-dev,
  libsqlite3-dev,
  libssl-dev,

## sqlsmith 1.4

=== debian/changelog ===
sqlsmith (1.4-1build4) plucky; urgency=medium

  * No-change rebuild for libpqxx-7.10.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 24 Jan 2025 21:10:47 +0000

sqlsmith (1.4-1build3) oracular; urgency=medium

  * Rebuild against new libpqxx-7.9.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Jul 2024 11:59:37 +0200

sqlsmith (1.4-1build2) noble; urgency=high

  * No change rebuild against libpqxx-7.8t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 17:01:59 +0200

sqlsmith (1.4-1build1) noble; urgency=medium

  * Rebuild against new libpqxx-7.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2023 11:32:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: sqlsmith
 Section: database
 Priority: optional
-Maintainer: Andreas Seltenreich <seltenreich@gmx.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andreas Seltenreich <seltenreich@gmx.de>
 Uploaders: Christoph Berg <myon@debian.org>
 Standards-Version: 4.6.0
 Homepage: https://github.com/anse1/sqlsmith
@@ -12,7 +13,7 @@
  autoconf-archive,
  debhelper-compat (= 12),
  libpq-dev,
- libpqxx-dev,
+ libpqxx-dev (>= 4.0),
  libsqlite3-dev,
  libssl-dev,
